#include "stm32f10x.h"
#include "obrazy.h"
//#include <stdio.h>

TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
TIM_ICInitTypeDef  TIM_ICInitStructure;
TIM_OCInitTypeDef  TIM_OCInitStructure;

void RCC_Conf(void);
void NVIC_Conf(void);
void GPIO_Conf(void);
void TIM1_Config(void);
void TIM2_Config(void);
void USART_Config(void);

void obrazek(uint8_t tablica[3][96][6]);
void brak(void);
void ocean(void);



//void Jedna_Linia(void);

__IO uint32_t cnt;
__IO uint32_t CC1;
__IO uint32_t a=0, aa=0;
__IO uint8_t b = 0, c = 1, d = 1, k = 0, z = 0;
__IO uint16_t cnt1=0, cnt2=0, cnt3=0, cnt4=0, cnt5=0, cnt6=0;
__IO uint32_t cntcnt;
__IO uint8_t RxBuf[3]={0, 0x0D, 0};
__IO uint8_t RxIndex;
__IO uint8_t odebrano_polecenie;
__IO uint8_t czerwony=1;
__IO uint8_t zielony=1;
__IO uint8_t niebieski=1;
__IO uint8_t obraz=2;
__IO uint8_t anim=0;
__IO uint8_t stan;
__IO uint8_t przesuniecie=0;
__IO uint8_t p=0;
__IO uint8_t obrot=1;
extern uint8_t TxBuf[];



int main(void)
{
	#ifdef DEBUG
  		debug();
	#endif

  	RCC_Conf();
  	NVIC_Conf();
  	GPIO_Conf();
  	TIM1_Config();
  	TIM2_Config();
  	USART_Config();

  	//GPIO_SetBits(GPIOA, GPIO_Pin_0);
  	//GPIO_SetBits(GPIOA, GPIO_Pin_2);


  	//obraz=2;

  	while (1)
  	{
  		if(odebrano_polecenie)
  				{
  					if(RxBuf[0] == 'c')
  						czerwony = 1;
  					else if(RxBuf[0] == 'v')
  						czerwony = 0;
  					else if(RxBuf[0] == 'z')
  					  	zielony = 1;
  					else if(RxBuf[0] == 'x')
  					  	zielony = 0;
  					else if(RxBuf[0] == 'b')
  					  	niebieski = 1;
  					else if(RxBuf[0] == 'n')
  					  	niebieski = 0;
  					else if(RxBuf[0] == 'q')
  						obrot = 1;
  					else if(RxBuf[0] == 'w')
  					  	obrot = 0;


  					else if(RxBuf[0] == '1')
  					{
   						anim = 0;
  						obraz--;
   						if (obraz < 1) obraz = 9;
  					}

  					else if(RxBuf[0] == '2')
  					{
  						anim = 0;
  						obraz++;
   						if (obraz > 9) obraz = 1;
  					}

  					else if(RxBuf[0] == '3')
  					{
  						obraz = 0;
  						anim = 1;
  						aa = 0;
  					}

  					odebrano_polecenie = 0;
  				}

    	if (a != aa)
    	{
    		a = aa;

    		if ((0<=a) && (a<=20))
    			stan = 1;  	//ocean();

    		else if ((20<a) && (a<=60))
    			stan = 2;	//obrazek(map);

    		else if (((60<a) && (a<=75)) || ((110<a) && (a<=113)) || ((116<a) && (a<=119)))
    			stan = 1;	//ocean();
    		else if (((75<a) && (a<=110)) || ((113<a) && (a<=116)) || ((119<a) && (a<=122))) 	//35 map1
    			stan = 3;	//obrazek(map1);


    		else if (((122<=a) && (a<=140)) || ((175<a) && (a<=178)) || ((181<a) && (a<=184)))
    			stan = 1;  	//ocean();
    		else if (((140<a) && (a<=175)) || ((178<a) && (a<=181)) || ((184<a) && (a<=187)))
    		    stan = 4;	//obrazek(map3);


    		else if (((187<=a) && (a<=205)) || ((240<a) && (a<=243)) || ((246<a) && (a<=249)))
    			stan = 1;  	//ocean();
    		else if (((205<a) && (a<=240)) || ((243<a) && (a<=246)) || ((249<a) && (a<=252)))
    		    stan = 5;	//obrazek(map3);


    		else if (((252<=a) && (a<=270)) || ((305<a) && (a<=308)) || ((311<a) && (a<=314)))
    			stan = 1;  	//ocean();
    		else if (((270<a) && (a<=305)) || ((308<a) && (a<=311)) || ((314<a) && (a<=317)))
    		    stan = 6;	//obrazek(map4);


    		else if (((317<=a) && (a<=335)) || ((370<a) && (a<=373)) || ((376<a) && (a<=379)))
    			stan = 1;  	//ocean();
    		else if (((335<a) && (a<=370)) || ((373<a) && (a<=376)) || ((379<a) && (a<=382)))
    		    stan = 7;	//obrazek(map5);

    		else aa=0;

    	}

  	}
}

void RCC_Conf(void)
{
  	ErrorStatus HSEStartUpStatus;

  	// Reset ustawien RCC
  	RCC_DeInit();

  	// Wlacz HSE
  	RCC_HSEConfig(RCC_HSE_ON);

  	// Czekaj za HSE bedzie gotowy
  	HSEStartUpStatus = RCC_WaitForHSEStartUp();

  	if(HSEStartUpStatus == SUCCESS)
  		{
    	FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    	// zwloka dla pamieci Flash
    	FLASH_SetLatency(FLASH_Latency_2);

   		// HCLK = SYSCLK
    	RCC_HCLKConfig(RCC_SYSCLK_Div1);

    	// PCLK2 = HCLK
    	RCC_PCLK2Config(RCC_HCLK_Div1);

    	// PCLK1 = HCLK/4
    	RCC_PCLK1Config(RCC_HCLK_Div2);

    	// PLLCLK = 8MHz * 9 = 72 MHz
    	RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    	// Wlacz PLL
    	RCC_PLLCmd(ENABLE);

    	// Czekaj az PLL poprawnie sie uruchomi
    	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);

    	// PLL bedzie zrodlem sygnalu zegarowego
    	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    	// Czekaj az PLL bedzie sygnalem zegarowym systemu
    	while(RCC_GetSYSCLKSource() != 0x08);

  		// Wlacz taktowanie GPIOB i TIM2
  		RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
  		RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1 | RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1 | RCC_APB2Periph_AFIO, ENABLE);
  	}
}

void GPIO_Conf(void)
{
  	GPIO_InitTypeDef GPIO_InitStructure;
  	GPIO_InitTypeDef GPIO_Conf;


  	// PA1 wejsciem drugiego kanalu TIM2
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOA, &GPIO_InitStructure);

  	// Konfiguracja wyjsc sterujacych rejestrami przesuwnymi
  	GPIO_Conf.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_6 ;
  	GPIO_Conf.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_Conf.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOA, &GPIO_Conf);

	GPIO_ResetBits(GPIOA, GPIO_Pin_0 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_6);

	//GPIO_SetBits(GPIOA, GPIO_Pin_0 | GPIO_Pin_2 );

	//PA0 - R0,	PA2 - G0, PA3 - B0, PA4 - RCLK, PA6 - SRCLK



  	// Konfiguracja PA9 jako Tx
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

  	GPIO_Init(GPIOA, &GPIO_InitStructure);

  	// Konfiguracja PA010 jako Rx
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;

  	GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void NVIC_Conf(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

	#ifdef  VECT_TAB_RAM
  		// Jezeli tablica wektorow w RAM, to ustaw jej adres na 0x20000000
  		NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
	#else  // VECT_TAB_FLASH
  		// W przeciwnym wypadku ustaw na 0x08000000
  		NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
	#endif
  	  	// Wybranie grupy priorytetw
  	 	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

  	// Wlacz przerwanie od TIM1
  	NVIC_InitStructure.NVIC_IRQChannel = TIM1_CC_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);

  	// Wlacz przerwanie od TIM2
  	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);


  	// Wlacz przerwanie od USART1
  	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
}

void TIM2_Config(void)
{
  	// Konfiguracja ukladu podstawy czasu
  	TIM_TimeBaseStructure.TIM_Period = 65535;
  	TIM_TimeBaseStructure.TIM_Prescaler = 1440; //fclk = 72MHz/1440 = 50kHz
  	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

  	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

  	// Konfiguracja kanalu 2 jako "input capture"
  	TIM_ICInitStructure.TIM_Channel = TIM_Channel_2;

  	// Bedzie reagowal na zbocze narastajace
  	TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Falling;
  	TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI;

  	// Nie uzywamy preskalera, kazde zdarzenie jest uwzgledniane
  	TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;
	// Nie uzywamy filtra
  	TIM_ICInitStructure.TIM_ICFilter = 0;

  	TIM_ICInit(TIM2, &TIM_ICInitStructure);

  	TIM_ITConfig(TIM2, TIM_IT_CC2, ENABLE);  // Waczenie przerwania od TIM2

  	// Wlaczenie timera
  	TIM_Cmd(TIM2, ENABLE);
}

void TIM1_Config(void)
{
  	// Konfiguracja ukladu podstawy czasu
  	TIM_TimeBaseStructure.TIM_Period = 65535;
  	TIM_TimeBaseStructure.TIM_Prescaler = 1440; //fclk = 72MHz/1440 = 50kHz
  	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

  	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);

  	// Konfiguracja kanalu 1
  	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_Timing;
  	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  	TIM_OCInitStructure.TIM_Pulse = CC1;
  	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
  	TIM_OC1Init(TIM1, &TIM_OCInitStructure);

  	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Disable);

  	// Wlaczenie przerwan od kanalow
  	TIM_ITConfig(TIM1, TIM_IT_CC1, ENABLE);

  	// Wlaczenie timera
  	TIM_Cmd(TIM1, ENABLE);
}

void USART_Config(void)
{
	USART_InitTypeDef USART_InitStructure;
	// Konfiguracja USART
  	USART_InitStructure.USART_BaudRate = 57600;
  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  	USART_InitStructure.USART_StopBits = USART_StopBits_1;
  	USART_InitStructure.USART_Parity = USART_Parity_No;
  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

	USART_Init(USART1, &USART_InitStructure);

	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
	USART_Cmd(USART1, ENABLE);
}

void obrazek(uint8_t tablica[3][96][6])
{
	GPIOA->BRR = GPIO_Pin_4;				//GPIO_ResetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK

	for (d=0 ; d<6 ; d++)
		{
			for (k=0 ; k<8 ; k++)
			{
				z = (128)>>k;

				if (czerwony)
				{
					if ((tablica[0][c][d] & z) == z)		//R0
						GPIOA->BRR = GPIO_Pin_0;				//GPIO_ResetBits(GPIOA, GPIO_Pin_0);
					else GPIOA->BSRR = GPIO_Pin_0;				//GPIO_SetBits(GPIOA, GPIO_Pin_0);
				}
				else GPIOA->BSRR = GPIO_Pin_0;				//GPIO_SetBits(GPIOA, GPIO_Pin_0);

				if (zielony)
				{
					if ((tablica[1][c][d] & z) == z)		//G0
						GPIOA->BRR = GPIO_Pin_2;				//GPIO_ResetBits(GPIOA, GPIO_Pin_2);
					else GPIOA->BSRR = GPIO_Pin_2;				//GPIO_SetBits(GPIOA, GPIO_Pin_2);
				}
				else GPIOA->BSRR = GPIO_Pin_2;				//GPIO_SetBits(GPIOA, GPIO_Pin_2);

				if (niebieski)
				{
					if ((tablica[2][c][d] & z) == z)		//B0
						GPIOA->BRR = GPIO_Pin_3;				//GPIO_ResetBits(GPIOA, GPIO_Pin_3);
					else GPIOA->BSRR = GPIO_Pin_3;				//GPIO_SetBits(GPIOA, GPIO_Pin_3);
				}
				else GPIOA->BSRR = GPIO_Pin_3;				//GPIO_SetBits(GPIOA, GPIO_Pin_3);


				GPIOA->BSRR = GPIO_Pin_6;				//GPIO_SetBits(GPIOA, GPIO_Pin_6);		//Poziom wysoki na SRCLK
				GPIOA->BRR = GPIO_Pin_6;				//GPIO_ResetBits(GPIOA, GPIO_Pin_6);		//Poziom niski na SRCLK

		}
	}

	GPIOA->BSRR = GPIO_Pin_4;				//GPIO_SetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK
}

void brak(void)
{
	GPIO_ResetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK

	for (d=0 ; d<6 ; d++)
		{
			for (k=0 ; k<8 ; k++)
			{
				z = (128)>>k;

				GPIO_SetBits(GPIOA, GPIO_Pin_0);

				GPIO_SetBits(GPIOA, GPIO_Pin_2);

				GPIO_SetBits(GPIOA, GPIO_Pin_3);


				GPIO_SetBits(GPIOA, GPIO_Pin_6);		//Poziom wysoki na SRCLK
				GPIO_ResetBits(GPIOA, GPIO_Pin_6);		//Poziom niski na SRCLK

		}
	}

	GPIO_SetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK
}

void ocean(void)
{
	GPIO_ResetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK

	for (d=0 ; d<6 ; d++)
		{
			for (k=0 ; k<8 ; k++)
			{
				z = (128)>>k;

				GPIO_SetBits(GPIOA, GPIO_Pin_0);

				GPIO_SetBits(GPIOA, GPIO_Pin_2);

				//GPIO_ResetBits(GPIOA, GPIO_Pin_3);
				if (niebieski)
				{
						GPIO_ResetBits(GPIOA, GPIO_Pin_3);
				}
				else GPIO_SetBits(GPIOA, GPIO_Pin_3);


				GPIO_SetBits(GPIOA, GPIO_Pin_6);		//Poziom wysoki na SRCLK
				GPIO_ResetBits(GPIOA, GPIO_Pin_6);		//Poziom niski na SRCLK

		}
	}

	GPIO_SetBits(GPIOA, GPIO_Pin_4);		//Poziom niski na RCLK
}


#ifdef  DEBUG
void assert_failed(uint8_t* file, uint32_t line)
{
  	while (1);
}
#endif


