#include "stm32f10x.h"

#ifndef TERMINAL_H_
#define TERMINAL_H_

// atrybuty znaku
#define RESET		0
#define BOLD 		1
#define DIM			2
#define UNDERLINE 	3
#define BLINK		4
#define REVERSE		7
#define HIDDEN		8

// kolory czcionki lub ta
#define BLACK 		0
#define RED			1
#define GREEN		2
#define YELLOW		3
#define BLUE		4
#define MAGENTA		5
#define CYAN		6
#define	WHITE		7

void Usart_SendC(USART_TypeDef* USARTx, uint16_t Data);
void Usart_SendS(USART_TypeDef* USARTx, char *s);
void Usart_SendInt(USART_TypeDef* USARTx, int value, int radix);
char* itoa(int value, char* buffer, int base);
//void __reverse(char* begin,char* end);
void tr_cls(USART_TypeDef* USARTx, uint8_t cur_onoff);						// kasuj ekran , w/wy kursor
void tr_cursor_hide(USART_TypeDef* USARTx, uint8_t hide );				// cursor show=0 / hide=1
void tr_locate(USART_TypeDef* USARTx, uint8_t y, uint8_t x );				// ustaw wiersz i kolumn
void tr_pen_color(USART_TypeDef* USARTx, uint8_t cl );					// ustaw kolor czcionki
void tr_brush_color(USART_TypeDef* USARTx, uint8_t cl );					// ustaw kolor ta
void tr_attr(USART_TypeDef* USARTx, uint8_t atr, uint8_t fg, uint8_t bg );// ustaw atrybut: znaku oraz kolor czcionki i ta

void fill_line(USART_TypeDef* USARTx, char ascii, uint8_t cnt );


#endif /* MK_TERM_H_ */
